/**
  ******************************************************************************
  * @file    vk0192.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk0192 functions. 
	*          ļ VK0192
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk0192.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK0192_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK0192ο·
unsigned char vk0192_segtab[VK0192_SEGNUM]={
	0,1,2,3,4,5,6,7,8,9,						//SEG0-SEG9
	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
	20,21,22,23,										//SEG20-SEG23
};
//LCDʵֻSEG10SEG21ʹ
//.hļVK0192_SEGNUM=12
//const unsigned char vk0192_segtab[VK0192_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vk0192_dispramӦоƬʾRAM
unsigned char vk0192_dispram[VK0192_SEGNUM];
//Ӧvk0192_segtab[VK0192_SEGNUM]
//ʾRAM bufferʹ8λbit0->com0,bit1->com1,...,bit7->com7
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vk0192_dispram[VK0192_SEGNUM]=
{//com7   com6   com5     com4   com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	 1D,     1E,    1F,      1A,    ,     1C,    1G,      1B,  //seg0   			vk0192_dispram[0]
	 2D,     2E,    2F,      2A,    ,     2C,    2G,      2B,  //seg1   			vk0192_dispram[1]
	 3D,     3E,    3F,      3A,    ,     3C,    3G,      3B,  //seg2   			vk0192_dispram[2]
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xF5,0x05,0xD3,0x97,0x27,0xB6,0xF6,0x15,0xF7,0xB7,0x02,0xE0,0xC6,0x67,0x05
};
unsigned char vk0192_addrbit=6;//icramַA5-A0,
unsigned char vk0192_segi,vk0192_comi;
unsigned char vk0192_maxcom;//com8com
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVk0192(void)
{
	VK0192_WR_L(); 
	delay_nus(VK0192_CLK);
	VK0192_WR_H();	
	delay_nus(VK0192_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVk0192(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VK0192_CS_L();   //CS Ƭѡ   
	delay_nus(VK0192_CLK/2);
	VK0192_DATA_H();  
	WriteClockVk0192();
	VK0192_DATA_L();  
	WriteClockVk0192();
	VK0192_DATA_L();  
	WriteClockVk0192();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VK0192_DATA_H(); 
	 else 
		 VK0192_DATA_L();	  

	 WriteClockVk0192();
	 Shift = Shift >> 1;
	}
  VK0192_DATA_L(); 
	WriteClockVk0192();	//һ0һλ X
  VK0192_CS_H(); 			//CS Ƭѡ  
	delay_nus(VK0192_CLK/2);
  VK0192_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽ8bit)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVk0192(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VK0192_CS_L();  //CS Ƭѡ
	delay_nus(VK0192_CLK/2);

	VK0192_DATA_H();  
	WriteClockVk0192();  //101
	VK0192_DATA_L();  
	WriteClockVk0192();
	VK0192_DATA_H();  
	WriteClockVk0192();

	for( i = 0; i < vk0192_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK0192_DATA_H(); 		
		else  
			VK0192_DATA_L();
		WriteClockVk0192();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 8; i++) 
	{

		if( Dat & Shift) 
			VK0192_DATA_H();		 
   	else  
			VK0192_DATA_L();
		WriteClockVk0192();
		Shift = Shift << 1;
	}   
  VK0192_CS_H(); //CS Ƭѡ
	delay_nus(VK0192_CLK/2);	
  VK0192_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽ8bit)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVk0192(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VK0192_CS_L();   //CS Ƭѡ 
	delay_nus(VK0192_CLK/2);

	VK0192_DATA_H();  
	WriteClockVk0192();  //101
	VK0192_DATA_L();  
	WriteClockVk0192();
	VK0192_DATA_H();  
	WriteClockVk0192();

	Shift = 0x20;
	for( i = 0; i < vk0192_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK0192_DATA_H(); 		
		else  
			VK0192_DATA_L();
		WriteClockVk0192();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 8; i++) 
		{
			if( dataval & Shift) 
				VK0192_DATA_H();		 
			else  
				VK0192_DATA_L();
			WriteClockVk0192();
			Shift = Shift << 1;
		}   
	}
  VK0192_CS_H();   //CS Ƭѡ
	delay_nus(VK0192_CLK/2);	 
  VK0192_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vk0192_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0xffȫ 0x00ȫ 0x55 0xaa 0x33 
* Input          dat->дram(1ֽ8bit)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[32];
	
	for(segi=0;segi<32;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVk0192(0,dispram,24);//8bitַԶ2(ÿ4bitݵַԶ1)
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVk0192(seg*2,(1<<com));//8bitݣÿ4bitݵַ18bitݵַҪ2
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVk0192(seg*2,~(1<<com));//8bitݣÿ4bitݵַ18bitݵַҪ2
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVk0192(OSC_OFF);
	WriteCommandVk0192(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_Exit_Standby(void)
{	
	//˳͹״̬vk0192
	WriteCommandVk0192(OSC_ON);
	WriteCommandVk0192(DISP_ON);
	vk0192_maxcom=8;	//1/4bias 8com
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK0192_CS_PORT, VK0192_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK0192_RD_PORT, VK0192_RD_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK0192_WR_PORT, VK0192_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK0192_DAT_PORT, VK0192_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
//	GPIO_SetMode(VK0192_DAT_PORT, VK0192_DAT_PIN, GPIO_MODE_QUASI); //ҪΪ˫IOڶʱΪIO
		
	VK0192_CS_H();      
	VK0192_RD_H();  //RDŲߵƽ                  
	VK0192_WR_H();  
	VK0192_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk0192_Lowlevel_Init();
	//
	WriteCommandVk0192(OSC_ON);
	WriteCommandVk0192(DISP_ON);
	vk0192_maxcom=8;	//1/4bias 8com
	//ϵĬ(δùܹرս͹)
	WriteCommandVk0192(IRQ_DIS);
	WriteCommandVk0192(TIMER_DIS);
	WriteCommandVk0192(WDT_DIS);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vk0192_dispram[0]&=0x08;
	vk0192_dispram[0]|=shuzi_zimo[dat8];
	
	dat8=dat/10%10; 	//ʾʮλ
	vk0192_dispram[1]&=0x08;
	vk0192_dispram[1]|=shuzi_zimo[dat8];
	
	dat8=dat%10;			//ʾλ
	vk0192_dispram[2]&=0x08;
	vk0192_dispram[2]|=shuzi_zimo[dat8];
		
	if(dat<100)				//С100λʾ
	{
		vk0192_dispram[0]&=0x08;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vk0192_dispram[1]&=0x08;
	}
	//SEG11
//	Write1DataVk0192(0*2,vk0192_dispram[0]);
//	Write1DataVk0192(1*2,vk0192_dispram[1]);
//	Write1DataVk0192(2*2,vk0192_dispram[2]);
	//SEGͶ
	WritenDataVk0192(0,&vk0192_dispram[0],3);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk0192_Main(void)
{	
	Vk0192_Init();
	Vk0192_DisAll(0x00);
	while(1)
	{
		Vk0192_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk0192_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk0192_DisAll(0x00);			//LCDȫ
		for(vk0192_segi=0;vk0192_segi<VK0192_SEGNUM;vk0192_segi++)//seg
		{
			for(vk0192_comi=0;vk0192_comi<vk0192_maxcom;vk0192_comi++)//com
			{
				Vk0192_DisSegComOn(vk0192_segtab[vk0192_segi],vk0192_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk0192_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk0192_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk0192_segi=0;vk0192_segi<VK0192_SEGNUM;vk0192_segi++)//seg
		{
			for(vk0192_comi=0;vk0192_comi<vk0192_maxcom;vk0192_comi++)//com
			{
				Vk0192_DisSegComOff(vk0192_segtab[vk0192_segi],vk0192_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk0192_DisAll(0xff);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk0192_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk0192_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk0192_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
