/**
  ******************************************************************************
  * @file    vk0192.h 
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   Header files for Vk0192
  ******************************************************************************
  * @attention
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __VK0192_H
#define __VK0192_H

/* Includes ------------------------------------------------------------------*/
//˰ļݿͻƬӦ޸
#include "M451Series.h"
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
//
#define OSC_OFF    	0x00         				// ر
#define OSC_ON    	0x01         				// 
#define DISP_OFF 		0x02								// LCD Bias
#define DISP_ON   	0x03         				// LCD Bias
//չùܿδܽţرտɽ͹
#define TIMER_DIS   0x04         				// 
#define WDT_DIS   	0x05         				// 
#define RC32K  			0X18         				// 
#define IRQ_DIS  		0X80        				// 

//seg
#define 	VK0192_SEGNUM		24

//¹ܽøݿͻƬӦ޸ 
#define VK0192_CS_PIN         BIT12
#define VK0192_CS_PORT        PA
#define VK0192_CS_IO          PA12

#define VK0192_RD_PIN         BIT14
#define VK0192_RD_PORT        PA
#define VK0192_RD_IO          PA14

#define VK0192_WR_PIN         BIT13
#define VK0192_WR_PORT        PA
#define VK0192_WR_IO          PA13

#define VK0192_DAT_PIN        BIT15
#define VK0192_DAT_PORT       PA
#define VK0192_DAT_IO         PA15

//¹ܽݿͻƬӦ޸
#define VK0192_CS_H() 				VK0192_CS_IO = 1 	//CS͸ߵƽ
#define VK0192_CS_L() 				VK0192_CS_IO = 0 	//CS͵͵ƽ 

#define VK0192_RD_H() 				VK0192_RD_IO = 1 	//RD͸ߵƽ 
#define VK0192_RD_L() 				VK0192_RD_IO = 0 	//RD͵͵ƽ 

#define VK0192_WR_H() 				VK0192_WR_IO = 1 	//WR͸ߵƽ 
#define VK0192_WR_L() 				VK0192_WR_IO = 0 	//WR͵͵ƽ 

#define VK0192_DATA_H() 			VK0192_DAT_IO = 1 //WR͸ߵƽ 
#define VK0192_DATA_L() 			VK0192_DAT_IO = 0 //WR͵͵ƽ 
/* Exported functions ------------------------------------------------------- */
void Vk0192_Init(void);
void Vk0192_DisAll(unsigned char dat);
void Vk0192_DisSegComOn(unsigned char seg,unsigned char com);
void Vk0192_DisSegComOff(unsigned char seg,unsigned char com);

void Vk0192_Main(void);
#endif  /*__VK0192_H*/

/************************END OF FILE****/
